<?php
function fz_tenniscourt_substitute($str, $filter, $format, $langcode) {
  $ms = array ();
  $s_minta = "/\[tenniscourt\][^\[]*\[\/tenniscourt\]/msxi";    
  
  $is_s = preg_match( $s_minta, $str, $ms );
  
  if ($is_s === 0) {
    return $str;
  }  
  $mp = drupal_get_path ( 'module', 'fz_tenniscourt' );
  $m = $ms[0];
  $ok = False;
  
    
  $s = array ("[tenniscourt]","[/tenniscourt]");
  $r = array ("","","");  
  $m = str_ireplace ( $s, $r, $m );         
  $m = str_ireplace ( "<p>", "", $m );
  $m = str_ireplace ( "</p>", "\n\n", $m );
  $m = str_ireplace ( "<br>", "\n", $m );
  $m = preg_replace ( "/<br[^\/]*\/>/", "", $m );
  
  $tcourt  = jsadd($mp);
  $tcourt .= jsdiv();
  $tcourt .= fz_tenniscourt_convert ( $m, $mp);
  $str = preg_replace ( $s_minta, $tcourt, $str, 1 );  
  return $str;
}
function jsdiv(){
  return "\n<div id='fz_tenniscourt' class='fz_tenniscourt' style='text-align:center;margin-left:auto;margin-right:auto;'></div>\n";
}
function jsadd($mp){
  drupal_add_css ( $mp . "/fz_tenniscourt.css" );
  $t = "\n";
  $t .= "<script src='".$mp."/js/three.min.js'></script>\n";
  $t .= "<script src='".$mp."/js/OrbitControls.js'></script>\n";
  $t .= "<script src='".$mp."/js/stats.min.js'></script>\n";
  $t .= "<script src='".$mp."/js/dat.gui.min.js'></script>\n";    
  return $t;
}
/**
 * Convert a text to tenniscourt format
 *
 * @param string $txt
 * @return string - text with chords
 */
function fz_tenniscourt_convert($txt, $mp) {
  $t  = "<script type='module'>\n";    
  $t .= "import {init, animate, arces, players, court, css, axis} from './".$mp."/js/fz_tennis.js';\n";
  $t .= fz_tenniscourt_getparams($txt);
  $t .= "init();\n";
  $t .= "animate();\n";  
  $t .= "</script>\n";  
  return $t;
}

function fz_tenniscourt_getparams($txt){
  $pat = "/{ball;[^}]*}/msxi";
  $arc = array();
  $btemplate = array("x0"=>0, "y0"=>0, "z0"=>0, "x1" =>100, "y1"=>100, "z1"=>0, "h"=>10, "spin"=>"normal", "text" => "", "color"=>"0xffff20");
  $okarc = preg_match_all( $pat, $txt, $match );
  
  if($okarc){    
    foreach( $match[0] AS $m){
      $m    = str_replace(array("{ball;","}"),"",$m);
      $pars = explode(";",$m);
      $temp = $btemplate;
      foreach($pars As $p){        
        $ie = explode(":",$p);
        if(count($ie)>1){
          $i  = trim($ie[0]);
          $e  = trim($ie[1]);        
          $temp[$i] = $e;    
        }
      }            
      $arc[] = $temp;      
    }    
  }
  
  //parameters of players
  $pat = "/{player;[^}]*}/msxi";
  $player = array();
  $ptemplate  = array("x0"=>0, "y0"=>0,"angle" => 0, "text" =>"", "play"=>"forehand");
  $okplayer   = preg_match_all($pat, $txt, $match);  
  if($okplayer){    
    foreach( $match[0] AS $m){
      $m    = str_replace(array("{player;","}"),"",$m);
      $pars = explode(";",$m);
      $temp = $ptemplate;
      foreach($pars AS $p){
        $ie = explode(":",$p);
        $i = trim($ie[0]);
        $e = trim($ie[1]);
        $temp[$i] = $e;
      }
      $player[] = $temp;
    }
  }
  
  $out = "";
  $arctemplate = "arces.push({x0:[x0],y0:[y0],z0:[z0],x1:[x1],y1:[y1],z1:[z1], h:[h], spin:\"[spin]\", text:\"[text]\",color:\"[color]\"});\n";
  foreach($arc AS $a){
    $m = $arctemplate;
    foreach($a As $i => $e){
      $m = str_replace("[".$i."]",$e,$m);      
    }
    $out .= $m; 
  }
    
  $playertemplate ="players.push({x0:[x0],y0:[y0],angle:[angle],text:\"[text]\",play:\"[play]\"});\n";
  foreach($player AS $p){
    $m = $playertemplate;
    foreach($p AS $i => $e){
      $m = str_replace("[".$i."]",$e,$m);      
    }
    $out .= $m;
  }

  $court = "court.pathname= \"".drupal_get_path("module","fz_tenniscourt")."/\";\n";
  $cot = "/{court:[^}]*}/msxi";
  $okcourt = preg_match_all($cot, $txt, $match);  
  if($okcourt){    
    $m = trim(strtolower(str_replace(array("{court:","}"),"",$match[0][0])));
    if($m == "clay"){
      $court .= "court.wrap = \"clay\";\n";
      $out   .= $court;
    }
  }

     
  $st = "/{style:[^}]*}/msxi";  
  $okstyle = preg_match_all($st, $txt, $match);
  if($okstyle){    
     $m = strtolower(str_replace("style:","",$match[0][0]));
     drupal_add_css("div#fz_tenniscourt ".$m,array("type"=>'inline', 'weight'=>100));
  }
    
  $ax= "/{axis:[^}]*}/msxi";
  $okax = preg_match_all($ax, $txt, $match);
  if($okax){
    $out .= "axis.push(true);\n"; 
  }else{
    $out .= "axis.push(false);\n";
  }
  
  return $out;
}
