//size of court
 
var singlew = 9.0;	// single court
var doublew = 12;   // double court
var length  = 26.0;
var tz = 50; //max height
//
//size of net
var tnw = 11;
var tnh = 1;

var camera, scene, renderer, controls, container;

//Camera position x, y, z
var cx = -2;
var cy = -35;
var cz = 10;

var gui;

var matsingle = {color: 0x6666ff};
var matdouble = {color: 0x9999ff};
var matserv   = {color: 0x7777ff};
var ballmat   = {color: 0xffff20, side: THREE.DoubleSide};
var color     = {color: 0xeeeeee, side: THREE.DoubleSide};

var court = {wrap:"", pathname:""};

const geometry = [];
var   arces    = [];   //the lines...
var   players  = [];
var   css      = [];
var   axis     = [];

// Text shows
var   fontloader;
var   font;
//szöveg

THREE.Cache.enabled = true;

//Write out a rectangle (single, pair,)
function Rect(w,h,x,y, mat){
	const points = [];
	var material = new THREE.MeshBasicMaterial(mat);	
	var geometry = new THREE.PlaneGeometry(w, h);	
    var line = new THREE.Mesh(geometry, material);
    line.position.set(x, y, 0);    
	scene.add(line);
}

// Doubles tennis court
function Doubles(){
    var w = doublew;
	var h = length;		
	if(court.wrap.toLowerCase() == "clay"){
		var loader = new THREE.TextureLoader();
		Rect(w,h,0,0, {map: loader.load(court.pathname +"image/clay.jpg")});
	}else{
		Rect(w,h,0,0, matdouble);
	}
}

//Single tennis court
function Single(){
	var w = singlew;
	var h = length;	
	if(court.wrap.toLowerCase() == "clay"){
		var loader = new THREE.TextureLoader();
		Rect(w,h,0,0, {map: loader.load(court.pathname +"image/claysingle.jpg"),});
	}
	else{
		Rect(w, h, 0, 0, matsingle);
	}
}

function ServeRect(w,h,x,y, mat){	
    var points = [];
	points.push( new THREE.Vector3( x  , y  , 0) );
	points.push( new THREE.Vector3( w+x, 0+y, 0) );
	points.push( new THREE.Vector3( w+x, h+y, 0) );
	points.push( new THREE.Vector3( 0+x, h+y, 0) );
	points.push( new THREE.Vector3( x  , y  , 0) );
	var geometry = new THREE.BufferGeometry().setFromPoints(points);
    var material = new THREE.LineBasicMaterial(color);
    var line = new THREE.Line(geometry, material);
    scene.add(line);	
}

function Serve(){
	var w = 0.5*singlew;
	var h = 7;
	Rect(singlew,2*h,0,0,matserv);
	var x = 0;
	var y = 0;	
	ServeRect(w,h,x,y, matserv);
	
	x =  0;
	y = -h;	
	ServeRect(w,h,x,y,matserv);

	x = -w;
	y = -h;	
	ServeRect(w,h,x,y,matserv);
	
	x = -w;
	y = 0;
	ServeRect(w,h,x,y, matserv);
}

function Net(){	
    var h = 0;
	var d = 1;
	var netmat = {color: 0x888888, side: THREE.DoubleSide};	
	var material = new THREE.MeshBasicMaterial(netmat);	
	var geometry = new THREE.PlaneGeometry(tnw, tnh, 25, 25);
	geometry.rotateX(-Math.PI* 0.5);	
    var net = new THREE.Line(geometry, material);
    net.position.set(0, 0 , d/2);
	scene.add(net);	
}

//arces of balls
function Arces(){
	for( var i = 0; i<arces.length;i++){
		arc(arces[i]);
	}
}
function arc(a){
    var geometry;	
	var line;
	var y = length/100;

	var dx = singlew / 2 ;
	var dy = length  / 2;
	var spin;
	var a;	
	var curve;
	var col;
	var material;
	var rgb;
	var text;
	var coner = 0.1;
	var coneh = 0.5;
	var n;	
	a.x0 *= singlew /100;
	a.y0 *= length /100; 
	a.x1 *= singlew /100;
	a.y1 *= length /100;
	
	// spinning ball
	var p = a.spin.trim().toLowerCase();
	if( p == "normal" || p == "spin"){
		spin = 0.5;		
	}else if(p == "topspin" || p ==  "top" || p == "t"){
	   spin = 0.3;	
	}else if(p == "backspin" || p == "back" || p == "b"){
		spin = 0.7;
	} else{
		n = Number(p);		
		if(n != NaN){
			if     ( n <= 0) spin = 0.099;
			else if(n >= 100) spin = 0.01;
			else spin = 1-n/100;
		}
	}

    rgb = new THREE.Color(a.color);
	if(rgb != undefined ){
        material = {color: rgb, side: THREE.DoubleSide };
	}else{
	    material = ballmat;
	}
	var kx =  (a.x0 * spin + a.x1*(1-spin));
	var ky =  (a.y0 * spin + a.y1*(1-spin));
	//curve
	var curvematerial = new THREE.LineBasicMaterial(material);		
	
	//curve
	var curvematerial = new THREE.LineBasicMaterial(material);		
	curve = new THREE.CatmullRomCurve3([
		new THREE.Vector3( a.x0 - dx, a.y0 - dy, a.z0),
		new THREE.Vector3( kx   - dx, ky - dy  , a.h ),
		new THREE.Vector3( a.x1 - dx, a.y1-dy  , a.z1)
	]);		
	geometry = new THREE.BufferGeometry().setFromPoints(curve.getPoints(50));
	line     = new THREE.Line(geometry, curvematerial);
	scene.add(line);
	
	if(a.z1 == 0){
		curve = new THREE.CatmullRomCurve3([
			new THREE.Vector3( a.x1 - dx, a.y1 - dy, 0),
			new THREE.Vector3( a.x1 + (a.x1-kx)/5 - dx, a.y1+(a.y1-ky)/5 - dy, a.h/5 ),
		]);	
		geometry = new THREE.BufferGeometry().setFromPoints(curve.getPoints(50));
		line     = new THREE.Line(geometry, curvematerial);
		scene.add(line);
	}
	//Cone
	var cone = new THREE.ConeGeometry(coner, coneh,16, 4) ;
	var coneMesh = new THREE.Mesh(cone, curvematerial);
	coneMesh.rotateZ(Math.atan2(a.x0-a.x1, -(a.y0-a.y1)));
	if(spin > 0.5){
		coneMesh.rotateX(Math.atan2(a.h, ky-a.z0)/2);
	}else if(spin < 0.5){
		coneMesh.rotateX(-Math.atan2(a.h, ky-a.z0));
	}
	coneMesh.position.set(kx-dx, ky-dy, a.h);
	scene.add(coneMesh);
		
	//Show Text				
	if(a.text !=""){			
		fontloader = new THREE.FontLoader();
		fontloader.load(court.pathname+"js/fonts/gentilis_regular.typeface.json", function( response){
			font = response;				
			createText(a.text, kx-dx, ky-dy, a.h, curvematerial );
		});
	}
}

function createText(t, x, y, z, mat){	
	var material = new THREE.MeshBasicMaterial(mat);
	var textGeom = new THREE.TextGeometry(t,{
		font: font,
		size: 0.2,	
		height: 0.005,
		curveSegments: 4, 
		bevelEnabled:true, 
		bevelThickness: 0.002, 
		bevelSize: 0.001
	})	  
	var textMesh = new THREE.Mesh(textGeom, material);	
	textGeom.computeBoundingBox();	
	var textWidth = textGeom.boundingBox.max.x - textGeom.boundingBox.min.x;
	var textHeight = textGeom.boundingBox.max.z - textGeom.boundingBox.min.z;	
	textMesh.position.set(x-textWidth / 2, y, z + 25*textHeight );
	textMesh.rotateX (Math.PI / 2);
	scene.add(textMesh);
}

function Players(){
	var p;
	for(var i = 0; i< players.length; i++){
		Player(players[i]);		
	}
}
//Vector3, x axis, y axis, z axis, hossz
function Vector3D(p, dx, dy, dz, beta) {
	var x,y,z;
	if(p.isVector3){
		x = p.x;
		y = p.y;
		z = p.z;	
	}else{
		x = p.x0;
		y = p.y0;
		z = 0;
	}

	if(beta != 0){		
		var r = Math.sqrt(dx*dx + dy*dy);
		var alfa;
		if(dx != 0){
			alfa = Math.atan2( dy, dx );	
		}else{
			if(dy ==0){
				alfa = 0;
			}else if(dy<0){
				alfa = -Math.PI / 2
			}else{
				alfa = Math.PI / 2;
			}			
		}
		alfa +=beta;		
		dx = Math.cos(alfa)*r;		
		dy = Math.sin(alfa)*r;		
	}
	return new THREE.Vector3(x + dx, y + dy, z + dz); 
}

function Player(a){
	a.x0 *= singlew / 100;
	a.y0 *= length  / 100
	a.angle = Math.PI*a.angle/180;
	var h = 2    ; // high is 2 feet, almost 2 meters
	
	
	var d    = 0.5*0.914 ;  // the legs
	var foot = 0.21;        // foot
	var rlength = 0.52*0.914
	var dx = singlew / 2 ;
	var dy = length  / 2;
	a.x0 -= dx;
	a.y0 -= dy
	var sh = 0.75;
	var points = []; 
	var p;
    if(a.play == "forehand"){
    	//Left leg
    	points = [];    	
    	p = Vector3D(a, 0 , 0 ,h*0.5, a.angle);
    	points.push(p);
    	p = Vector3D(p, -d/4 , d/4 , -h/4, a.angle);
    	points.push(p);
    	p = Vector3D(p, -d/6 , d/6 , -h/4, a.angle);
    	points.push(p);
    	p = Vector3D(p, -foot*0.3 , foot*1.4 , 0, a.angle);
    	points.push(p);
    	var geometry = new THREE.BufferGeometry().setFromPoints(points);
    	var material = new THREE.LineBasicMaterial(color);
        var lleg = new THREE.Line(geometry, material);
    	scene.add(lleg);
    	
    	//Right leg
    	points = [];    	
    	p = Vector3D(a, 0 , 0 , h*0.5, a.angle);
    	points.push(p);
    	p = Vector3D( p, d/2, -d/2, -h/4, a.angle);
    	points.push(p);
    	p = Vector3D( p, d/4, -d/2, -h*3/16, a.angle );
    	points.push(p);
    	p = Vector3D(p, foot*0.6 , foot*0.8, -h/16, a.angle);
    	points.push(p);
    	var geometry = new THREE.BufferGeometry().setFromPoints(points);
        var material = new THREE.LineBasicMaterial(color);
        var rleg = new THREE.Line(geometry, material);
        scene.add(rleg);

    	// left arm 
        points = [];
        p = Vector3D(a,    0, 0, h*sh, a.angle);    	
    	points.push(p);
    	p = Vector3D(p, -d/2, d, -0.2, a.angle);
    	points.push(p);
    	p = Vector3D(p, -d/2, d,    0, a.angle);
    	points.push(p);
    	var geometry = new THREE.BufferGeometry().setFromPoints(points);
    	var material = new THREE.LineBasicMaterial(color);
    	var larm = new THREE.Line(geometry, material);
    	scene.add(larm);
    
    	// right arm
    	points = [];    	
    	p = Vector3D(a,   0,  0 , h*sh, a.angle )
    	points.push(p);
    	p = Vector3D(p, +d/2,-d/2,-0.3, a.angle);
    	points.push(p);
    	p = Vector3D(p, +d/2,   0,   0, a.angle);
    	var p0 = p;
    	points.push(p);
    	
    	//Rocket
    	var dz = Math.sqrt(rlength*rlength-d*d/4)
    	p = Vector3D(p, d/2, 0, dz, a.angle);
    	points.push(p);    		
    	var geometry = new THREE.BufferGeometry().setFromPoints(points);
    	var material = new THREE.LineBasicMaterial(color);
    	var rocket = new THREE.Line(geometry, material);
    	scene.add(rocket);
    	
    	var dx = p.x-p0.x;
    	var dy = p.y-p0.y;
    	var dz = p.z-p0.z;
    	var dv = Math.sqrt(dx*dx+dy*dy);
    	var m  = Math.atan2( dz, dv);    	
    	var ex = 0.175*8.23/9;
    	var ey = 0.135*8.23/9;
    	var ez = ey*0.85;    
    	    	
        //RHead
    	var rmat = {color: 0xeedddd,side: THREE.DoubleSide};    	
        var shape = new THREE.Shape()
            .ellipse(  0, 0, ex,  ey,  0, 2*Math.PI, false, a.angle );
    	var geometry = new THREE.ShapeBufferGeometry(shape, 20);
        var hmaterial = new THREE.MeshBasicMaterial(rmat );        
        var rhead = new THREE.Mesh( geometry, hmaterial );
    	    	
    	geometry.rotateX(-Math.PI *0.5);
    	geometry.rotateY(-m);
    	geometry.rotateZ(a.angle);    	    	 
    	
        rhead.position.set(p.x, p.y, p.z);
        scene.add(rhead);
      
    } else if(a.play=="serve"){
    	//Left leg
    	points = [];    	
    	p = Vector3D(a,  0,  0,  h*0.5, a.angle);
    	points.push(p);
    	p = Vector3D(p, 0 , 0 , -h*0.5, a.angle);
    	points.push(p);
    	p = Vector3D(p, -foot*0.1, foot*0.9 , 0, a.angle);
    	points.push(p);
    	var geometry = new THREE.BufferGeometry().setFromPoints(points);
        var material = new THREE.LineBasicMaterial(color);
        var lleg = new THREE.Line(geometry, material);
    	scene.add(lleg);
    	
    	//Right leg
    	points = [];    	
    	p = Vector3D( a,  0,    0,  h*0.5, a.angle);
    	points.push(p);
    	p = Vector3D( p, d/2, +d/3, -h*0.2, a.angle);
    	points.push(p);
    	p = Vector3D( p,   0, -d/3, -h*0.2, a.angle);
    	points.push(p);
      	p = Vector3D(p,  0, foot*0.9 , -h*0.05, a.angle);
      	points.push(p);
    	var geometry = new THREE.BufferGeometry().setFromPoints(points);
        var material = new THREE.LineBasicMaterial(color);
        var rleg = new THREE.Line(geometry, material);
        scene.add(rleg);
               
    	// left arm
        points = [];    	
    	p = Vector3D(a, 0, 0 , h*sh, a.angle);
    	points.push(p);
    	p = Vector3D(p, -d/4, -d/3, -d/2, a.angle);
    	points.push(p);
    	p = Vector3D(p, -d/2, 0  , -d/2, a.angle);
    	points.push(p);    	
    	var geometry = new THREE.BufferGeometry().setFromPoints(points);
    	var material = new THREE.LineBasicMaterial(color);
    	var larm = new THREE.Line(geometry, material);
    	scene.add(larm);
 
    	// right arm
    	points = [];
    	p = Vector3D(a, 0, 0, h*sh, a.angle);
    	points.push(p);
    	p = Vector3D(p, +d/4, d/3, d/2, a.angle);
    	points.push(p);
    	p = Vector3D(p, +d/4, d/3, d/2, a.angle);
    	points.push(p);    	
    	//Rocket
    	var p0 = p
    	p = Vector3D(p, 0 , 0, d*0.9, a.angle);
    	points.push(p);    		
    	var geometry = new THREE.BufferGeometry().setFromPoints(points);
    	var material = new THREE.LineBasicMaterial(color);
    	var rocket = new THREE.Line(geometry, material);
    	scene.add(rocket);
    	    	
    	var ey = 0.175*8.23/9;
    	var ex = 0.135*8.23/9;
    	var ez = ey*0.85;    
      
       	var dx = p.x-p0.x;
    	var dy = p.y-p0.y;
    	var dz = p.z-p0.z;
    	var dv = Math.sqrt(dx*dx+dy*dy);
    	var m  = Math.atan2( dz, dv);    	
    	    	
        //RHead
    	var rmat = {color: 0xeedddd,side: THREE.DoubleSide};    	
        var shape = new THREE.Shape()
            .ellipse(  0, 0, ex,  ey,  0, 2*Math.PI, false, a.angle );
    	var geometry = new THREE.ShapeBufferGeometry(shape, 20);
        var hmaterial = new THREE.MeshBasicMaterial(rmat );        
        var rhead = new THREE.Mesh( geometry, hmaterial );
    	    	
    	geometry.rotateX(-Math.PI *0.5);
    	geometry.rotateZ(a.angle);    	    	 
    	
        rhead.position.set(p.x, p.y, p.z);
        scene.add(rhead);
      
    } else if(a.play=="backhand"){
    	//Left leg
    	points = [];    	
    	p = Vector3D(a, 0, 0, h/2, a.angle);
    	points.push(p);
    	p = Vector3D(p, -d/8, -d/2 , -h/4, a.angle);
    	points.push(p);
    	p = Vector3D(p, +d/6 , -d/2 , -3*h/16, a.angle);
    	points.push(p);
    	p = Vector3D(p, -foot*0.7 , 0 , -h/16, a.angle);
    	points.push(p);
    	
    	var geometry = new THREE.BufferGeometry().setFromPoints(points);
        var material = new THREE.LineBasicMaterial(color);
        var lleg = new THREE.Line(geometry, material);
    	scene.add(lleg);
    	
    	//Right leg
    	points = [];    	
    	p = Vector3D(a, 0, 0, h/2, a.angle);
    	points.push(p);
    	p = Vector3D( p, -d/4, 0, -h/4, a.angle );
    	points.push( p );
    	p = Vector3D( p, +d/4, 0, -h/4, a.angle );
    	points.push( p );
    	p = Vector3D(p, -foot*0.6 , foot*0.5 , 0, a.angle);
    	points.push( p );
    	
    	var geometry = new THREE.BufferGeometry().setFromPoints(points);
        var material = new THREE.LineBasicMaterial(color);
        var rleg = new THREE.Line(geometry, material);
        scene.add(rleg);
        
    	// left arm
        points = [];
        p = Vector3D(a, 0, 0, h*sh, a.angle);
    	points.push(p);
    	p = Vector3D(p, d/4,-d/2   , -d/2, a.angle);
    	points.push(p);
    	p = Vector3D(p, 0,-d*0.6 , -d/2, a.angle);
    	points.push(p);    	
    	var geometry = new THREE.BufferGeometry().setFromPoints(points);
    	var material = new THREE.LineBasicMaterial(color);
    	var larm = new THREE.Line(geometry, material);
    	scene.add(larm);
 
    	// right arm
    	points = [];    	
    	p = Vector3D(a, 0, 0, h*sh, a.angle);
    	points.push(p);
    	p = Vector3D(p, -d/2, d/3, -0.2, a.angle);
    	points.push(p);
    	p = Vector3D(p, -d/2, 0, 0, a.angle);
    	points.push(p);    	
    	var p0 = p;
    	p = Vector3D(p, -0.2*d , 0, d*0.9, a.angle);
    	points.push(p);    		
    	var geometry = new THREE.BufferGeometry().setFromPoints(points);
    	var material = new THREE.LineBasicMaterial(color);
    	var rocket = new THREE.Line(geometry, material);
    	scene.add(rocket);
    	
    	var ey = 0.175*8.23/9;
    	var ex = 0.135*8.23/9;
    	var ez = ey*0.85;    
      
       	var dx = p.x-p0.x;
    	var dy = p.y-p0.y;
    	var dz = p.z-p0.z;
    	var dv = Math.sqrt(dx*dx+dy*dy);
    	var m  = Math.atan2( dz, dv);    	
    	    	
        //RHead
    	var rmat = {color: 0xeedddd,side: THREE.DoubleSide};    	
        var shape = new THREE.Shape()
            .ellipse(  0, 0, ex,  ey,  0, 2*Math.PI, false, a.angle );
    	var geometry = new THREE.ShapeBufferGeometry(shape, 20);
        var hmaterial = new THREE.MeshBasicMaterial(rmat );        
        var rhead = new THREE.Mesh( geometry, hmaterial );
    	    	
    	geometry.rotateX(-Math.PI *0.5);
    	geometry.rotateZ(a.angle);    	    	     	
        rhead.position.set(p.x, p.y, p.z);
        scene.add(rhead);	        
    }

    // body
	points = [];
	points.push( new THREE.Vector3( a.x0, a.y0, h/2 ) );     	
	points.push( new THREE.Vector3( a.x0, a.y0, h*0.9 ) );
	var geometry = new THREE.BufferGeometry().setFromPoints(points);
    var material = new THREE.LineBasicMaterial(color);
    var body     = new THREE.Line(geometry, material);
	scene.add(body);
	
    //Head
    var head = new THREE.SphereBufferGeometry(0.15, 16,16);    
    var hmaterial = new THREE.MeshBasicMaterial( { color: 0xffff00 } );
    var circle = new THREE.Mesh( head, hmaterial );
    circle.position.set(a.x0, a.y0,  h*0.9);	
    scene.add( circle );
   
	if(typeof a.text !== 'undefined' && a.text != ""){	
		fontloader = new THREE.FontLoader();
		fontloader.load(court.pathname+"js/fonts/gentilis_regular.typeface.json", function( response){
			font = response;
			createText(a.text, a.x0, a.y0, 2.5, color );
		});
	}
}

function init() 
{
	scene = new THREE.Scene();
	scene.background = new THREE.Color( 0x444444 );

    Doubles(); 
	Single();
	Serve();
	Net();
	Arces();
	Players();
    
	//Axes
	if(axis[0]){
		const ax = new THREE.AxesHelper(2);	
		ax.position.x = -7;
		ax.position.y = -14;
		ax.position.z = 1;
		scene.add(ax);		
	}

     //inside this will be the tennis court
	renderer  = new THREE.WebGLRenderer( { antialias: true } );
	container = document.getElementById("fz_tenniscourt");		  
	const ml= getComputedStyle(container,'::before').getPropertyValue('margin-left');
	const mr= getComputedStyle(container,'::before').getPropertyValue('margin-right');
	const ta= getComputedStyle(container,'::before').getPropertyValue('text-align');
	var w = container.clientWidth;
	var h = container.clientHeight;	
    renderer.setSize( w , h);
    
    container.appendChild( renderer.domElement );

	//camera
    camera = new THREE.PerspectiveCamera( 30, w / h, 1, 100 );
    camera.position.set(cx,cy,cz);
    camera.up.set(0,0,1);
	//
	controls = new THREE.OrbitControls( camera, renderer.domElement );
	controls.minDistance = 5;
	controls.maxDistance = 100;
}
// Animation
function animate() {
    requestAnimationFrame( animate );
	renderer.render( scene, camera );
}

export {init, animate, arces, players, court, css, axis}